#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include "text.h"

const char* ssid = "QuadBot-E";
const char* password = "12345678";

WiFiServer server(100);
WiFiClient client;
String sendBuff;
byte RX_package[17] = {0};
byte callback_forward_package[5] = {0xff,0x55,0x02,0x01,0x01};
byte callback_back_package[5] = {0xff,0x55,0x02,0x01,0x02};
byte callback_leftmove_package[5] = {0xff,0x55,0x02,0x01,0x03};
byte callback_rightmove_package[5] = {0xff,0x55,0x02,0x01,0x04};
byte callback_turnleft_package[5] = {0xff,0x55,0x02,0x01,0x05};
byte callback_turnright_package[5] = {0xff,0x55,0x02,0x01,0x06};
byte Serial_package[5] = {0};
byte dataLen, index_a = 0;
char buffer[52];
unsigned char prevc=0;
bool isStart = false;
bool ED_client = true;
bool WA_en = false;

#define CMD_RUN 1
#define CMD_daiji 3
#define CMD_jiaozun 4
#define CMD_suijiao 5
#define CMD_padi 6
#define CMD_dazaohu 7
#define CMD_fuwoceng 8
#define CMD_zandou 9
#define CMD_dance1 10
#define CMD_dance2 11
#define CMD_dance3 12

void setup()
{
  Serial.setTimeout(10);
  Serial.begin(115200);

  WiFi.mode(WIFI_AP);
  WiFi.softAP(ssid,password,5);
  server.begin();
  delay(100);

  servo_14.attach(14, SERVOMIN, SERVOMAX);
  servo_12.attach(12, SERVOMIN, SERVOMAX);
  servo_13.attach(13, SERVOMIN, SERVOMAX);
  servo_15.attach(15, SERVOMIN, SERVOMAX);
  servo_16.attach(16, SERVOMIN, SERVOMAX);
  servo_5.attach(5, SERVOMIN, SERVOMAX);
  servo_4.attach(4, SERVOMIN, SERVOMAX);
  servo_2.attach(2, SERVOMIN, SERVOMAX);

  Servo_PROGRAM_Zero();
}
unsigned char readBuffer(int index_r)
{
  return buffer[index_r]; 
}
void writeBuffer(int index_w,unsigned char c)
{
  buffer[index_w]=c;
}
void runModule(int device)
{
  switch(device) 
  {
    case 0x0C:
    {   
      int val = readBuffer(12);
      switch (val)
      {
        case 0x01:       
            forward();//Serial.println("ok");
            //Serial.write(callback_forward_package,5);
            client.write(callback_forward_package,5);
            break;
        case 0x02:
            back();
            client.write(callback_back_package,5);
            break;
        case 0x03:
            leftmove();
            client.write(callback_leftmove_package,5);
            break;
        case 0x04:
            rightmove();
            client.write(callback_rightmove_package,5);
            break;
        case 0x05:
            turnleft();
            client.write(callback_turnleft_package,5);
            break;
        case 0x06:
            turnright();
            client.write(callback_turnright_package,5);
            break;
        default:
            break;
      }
    }break;
  }   
}
void parseData()
{ 
  isStart = false;
  int action = readBuffer(9);
  int device = readBuffer(10);
  switch(action)
  {
    case CMD_RUN:
    {
      runModule(device);
    }
    break;
    case CMD_daiji:
    {
      standby();//Serial.println("ok");
    }
    break;
    case CMD_jiaozun:
    {
      //zero();
    }
    break;
    case CMD_suijiao:
    {
      sleep();
    }
    break;
    case CMD_padi:
    {
      lie();
    }
    break;
    case CMD_dazaohu:
    {
      hello();
    }
    break;
    case CMD_fuwoceng:
    {
      pushup();
    }
    break;
    case CMD_zandou:
    {
      fighting();
    }
    break;
    case CMD_dance1:
    {
      dance1();
    }
    break;
    case CMD_dance2:
    {
      dance2();
    }
    break;
    case CMD_dance3:
    {
      dance3();
    }
    break;
  }
}
void loop()
{
  client = server.available();
  if (client)
  {
    WA_en = true;
    ED_client = true;
    Serial.println("[Client connected]");

    while (client.connected())
    {
      if (client.available())
      {
        unsigned char c = client.read()&0xff;
        Serial.write(c);
        if(c==0x55&&isStart==false)
        {
          if(prevc==0xff)
          {
            index_a=1; 
            isStart = true;
          }
        }
        else
        {
          prevc = c;
          if(isStart)
          {
            if(index_a==2)
            {
            dataLen = c; 
            }
            else if(index_a>2)
            {
              dataLen--;
            }
            writeBuffer(index_a,c);
          }
        }
        index_a++;
        if(index_a>120)
        {
          index_a=0; 
          isStart=false;
        }
        if(isStart&&dataLen==0&&index_a>3)
        { 
          isStart = false;
          parseData();
          index_a=0;
        }
      }
      if (Serial.available())
      {
        char c = Serial.read();
        sendBuff += c;
        client.print(sendBuff);
        Serial.print(sendBuff);
        sendBuff = "";
      }
      static unsigned long Test_time = 0;
      if (millis() - Test_time > 1000)
      {
        Test_time = millis();
        if (0 == (WiFi.softAPgetStationNum()))
        {
          //Serial.write(Stop,17);
          break;
        }
      }
    }
    //Serial.write(Stop,17);
    client.stop();
    Serial.println("[Client disconnected]");
  }
  else
  {
    if (ED_client == true)
    {
      ED_client = false;
      //Serial.write(Stop,17);
    }
  }
}
